/*
    Copyright© 2021 John Sennesael

    UsenetSearch is Free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    UsenetSearch is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with UsenetSearch.  If not, see <https://www.gnu.org/licenses/>.
*/

#pragma once

#include "usenetsearch/Except.h"

#include <netdb.h> // struct addrinfo

#include <chrono>
#include <string>
#include <vector>

namespace usenetsearch {

struct DnsResolveException: public UsenetSearchException
{
    DnsResolveException(const std::string& message):
        UsenetSearchException(message){}

    virtual ~DnsResolveException() = default;
};

std::vector<struct addrinfo> DnsResolve(
    const std::string& host,
    int port,
    const std::chrono::milliseconds& timeOut = std::chrono::milliseconds{5000}
);

} // namespace usenetsearch
