/*
    Copyright© 2021 John Sennesael

    UsenetSearch is Free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    UsenetSearch is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with UsenetSearch.  If not, see <https://www.gnu.org/licenses/>.
*/

#pragma once

#include <stdexcept>

namespace usenetsearch {

class UsenetSearchException: public std::exception
{
    std::string m_message;
public:

    UsenetSearchException(const std::string& message);

    virtual ~UsenetSearchException() = default;
    virtual const char* what() const noexcept override;

};

static constexpr const int ENOTFOUND{2001};

} // namespace usenetsearch
