/*
    Copyright© 2021 John Sennesael

    UsenetSearch is Free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    UsenetSearch is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with UsenetSearch.  If not, see <https://www.gnu.org/licenses/>.
*/

#pragma once

#include "usenetsearch/Configuration.h"

#include <codecvt>
#include <locale>
#include <regex>
#include <string>
#include <unordered_map>

namespace usenetsearch {

class Filter
{

    Configuration& m_config;
    std::vector<std::string> m_noSubtokenWords;
    std::unordered_map<std::unique_ptr<std::wregex>, std::wstring>
        m_eraseTokenRegexes;

public:

    explicit Filter(Configuration& config);
    void Init();
    bool ProcessNewsgroup(const std::string& newsgroup) const;
    std::string ProcessSearchString(const std::string& searchString) const;
    std::string ProcessToken(
        const std::string& token,
        const std::string& searchString
    ) const;

};

} // namespace usenetsearch
