/*
    Copyright© 2021 John Sennesael

    UsenetSearch is Free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    UsenetSearch is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with UsenetSearch.  If not, see <https://www.gnu.org/licenses/>.
*/

#pragma once

#include <chrono>
#include <string>

namespace usenetsearch {

class IoSocket
{

public:

    virtual ~IoSocket() = default;

    std::chrono::milliseconds ConnectionTimeout() const;
    void ConnectionTimeout(const std::chrono::milliseconds& timeOut);

    std::chrono::milliseconds IoTimeout() const;
    void IoTimeout(const std::chrono::milliseconds& timeOut);

    virtual std::string Read(size_t amount) = 0;
    std::string ReadUntil(std::string deliminator);
    virtual void Write(const std::string& data) = 0;

protected:

    std::chrono::milliseconds m_connectionTimeout{10000};
    std::chrono::milliseconds m_ioTimeout{0};

};


} // namespace usenetsearch
