/*
    Copyright© 2021 John Sennesael

    UsenetSearch is Free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    UsenetSearch is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with UsenetSearch.  If not, see <https://www.gnu.org/licenses/>.
*/

#include "usenetsearch/IoSocket.h"

#include <chrono>
#include <string>

namespace usenetsearch {

std::chrono::milliseconds IoSocket::ConnectionTimeout() const
{
    return m_connectionTimeout;
}

void IoSocket::ConnectionTimeout(const std::chrono::milliseconds& timeOut)
{
    m_connectionTimeout = timeOut;
}

std::chrono::milliseconds IoSocket::IoTimeout() const
{
    return m_ioTimeout;
}

void IoSocket::IoTimeout(const std::chrono::milliseconds& timeOut)
{
    m_ioTimeout = timeOut;
}

std::string IoSocket::ReadUntil(std::string deliminator)
{
    std::string result;
    while(true)
    {
        std::string buffer = Read(1);
        result += buffer;
        if (result.length() >= deliminator.length())
        {
            if (result.substr(result.length() - deliminator.length())
                == deliminator)
            {
                return result;
            }
        }
    }
    return result;
}

} // namespace usenetsearch
